//
// Test of class L2List
//
import java.io.*;
import java.util.Enumeration;
import L2List;
import ListException;

public class ListTest {
    static int number; // Used for input
    static StreamTokenizer input;

    public static void main(String args[]) {
        input = new StreamTokenizer(
            new BufferedReader(
                new InputStreamReader(System.in)
            )
        );
        input.parseNumbers();

        System.out.println("Test of class L2List.");

        L2List list = new L2List();

        printHelp();
        System.out.print(">");

        try {

            while (inputInteger()) {
                if (number == 1) {
                    list.removeAll();
                } else if (number == 2) {
                    list.moveToBeg();
                } else if (number == 3) {
                    list.moveToEnd();
                } else if (number == 4) {
                    list.moveForward();
                } else if (number == 5) {
                    list.moveBack();
                } else if (number == 6) {
                    System.out.print("Element>");
                    if (!inputInteger()) break;
                    list.addBefore(new Integer(number));
                } else if (number == 7) {
                    System.out.print("Element>");
                    if (!inputInteger()) break;
                    list.addAfter(new Integer(number));
                } else if (number == 8) {
                    list.removeBefore();
                } else if (number == 9) {
                    list.removeAfter();
                } else if (number == 10) {
                    System.out.println(
                        "" + list.elementBefore()
                    );
                } else if (number == 11) {
                    System.out.println(
                        "" + list.elementAfter()
                    );
                } else if (number == 12) {
                    // Just show list
                } else if (number == 0) {
                    break;
                } else {
                    printHelp();
                    System.out.print(">");
                    continue;
                }

                showList(list);
                System.out.print(">");
            }
        } catch (ListException e) {
            System.out.println("" + e);
        }
    }

    static void printHelp() {
        System.out.println(
            "Commands of list:\n" +
            "1  -- RemoveAll\n" +
            "2  -- MoveToBeginning\n" +
            "3  -- MoveToEnd\n" +
            "4  -- MoveForward\n" +
            "5  -- MoveBack\n" +
            "6  -- AddBefore\n" +
            "7  -- AddAfter\n" +
            "8  -- RemoveBefore\n" +
            "9  -- RemoveAfter\n" +
            "10 -- ElementBefore\n" +
            "11 -- ElementAfter\n" +
            "12 -- Show list\n" +
            "13 -- Help\n" +
            "0  -- Quit"
        );
    }

    // Type all elements of list and pointer position. Example
    //     1 2 3 9 _ 4 5    Pointer between 9 and 4
    //
    static void showList(L2List list) {
        Object curElem = null;

        try {
            if (!list.inEnd()) {
                curElem = list.elementAfter();
            }

            Enumeration listElements = list.elements();
            while (listElements.hasMoreElements()) {
                Object n = listElements.nextElement();
                if (n == curElem) {
                    System.out.print(" _");
                }
                System.out.print(" " + (Integer) n);
            }

        } catch (ListException e) {
            System.out.println("" + e);
        }

        if (curElem == null) { // Pointer is in the end of list.
            System.out.print(" _");
        }
        System.out.println("");
    }

    static boolean inputInteger() {
        try {
            if (input.ttype == StreamTokenizer.TT_EOF) return false;

            // Read a number
            do {
                input.nextToken();
                if (input.ttype == StreamTokenizer.TT_EOF) return false;
            } while (input.ttype != StreamTokenizer.TT_NUMBER);
            number = (int) input.nval;
            return true;

        } catch (IOException e) {
            System.out.println("Input error: " + e);
            return false;
        }
    }
}
